<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.17"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>print() for C++20: include/print_atom.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">print() for C++20
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.17 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_d44c64559bbebec7f509842c48db8b23.html">include</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">print_atom.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="print__atom_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">// Copyright (c) 2021 Martin B. Krauss.</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment">// Licensed under the MIT LICENSE.</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment">// See the file &#39;LICENSE&#39; that should be distributed with this software or can</span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment">// be found at &#39;https://gitlab.com/martin.b.krauss/cpp20-print&#39; for details.</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160; </div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#ifndef CPP20PRINT_PRINT_ATOM_H</span></div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">#define CPP20PRINT_PRINT_ATOM_H</span></div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160; </div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160; </div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="print__options_8h.html">print_options.h</a>&quot;</span></div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="print__concepts_8h.html">print_concepts.h</a>&quot;</span></div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160; </div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="keyword">namespace </span>cpp20print::printing::detail {</div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160; </div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">class</span> T&gt; </div>
<div class="line"><a name="l00022"></a><span class="lineno"><a class="line" href="print__atom_8h.html#ad47012d4b2f909cec110fa350eae7192">   22</a></span>&#160;<span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="print__atom_8h.html#ad47012d4b2f909cec110fa350eae7192">print_atom</a>(std::ostream&amp; out, <span class="keyword">const</span> <a class="code" href="structcpp20print_1_1printing_1_1PrintOptions.html">PrintOptions</a>&amp;, <span class="keyword">const</span> T&amp;) {</div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;    <span class="comment">//auto address = reinterpret_cast&lt;const int64_t&gt;(std::addressof(t));</span></div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;    <span class="comment">//std::stringstream buffer;</span></div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;    <span class="comment">//buffer &lt;&lt; std::hex &lt;&lt; address;</span></div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;    <span class="comment">//std::string string = &quot;&lt;NOT_PRINTABLE [0x&quot; + buffer.str() + &quot;]&gt;&quot;;</span></div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;    std::string <span class="keywordtype">string</span> = <span class="stringliteral">&quot;&lt;NOT_PRINTABLE&gt;&quot;</span>;</div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;    out &lt;&lt; string;</div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;}</div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160; </div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;<span class="keyword">template</span> &lt;concepts::Pr<span class="keywordtype">int</span>able T&gt; requires </div>
<div class="line"><a name="l00035"></a><span class="lineno"><a class="line" href="print__atom_8h.html#a08a0df05930aa51f1c30e856b5e6ff99">   35</a></span>&#160;    (concepts::PrintableInteger&lt;T&gt; == <span class="keyword">false</span>) &amp;&amp;</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;    (concepts::PrintableFloat&lt;T&gt; == <span class="keyword">false</span>)</div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;<span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="print__atom_8h.html#ad47012d4b2f909cec110fa350eae7192">print_atom</a>(std::ostream&amp; out, <span class="keyword">const</span> <a class="code" href="structcpp20print_1_1printing_1_1PrintOptions.html">PrintOptions</a>&amp;, <span class="keyword">const</span> T&amp; t) {</div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;    out &lt;&lt; t; </div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;}</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160; </div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">class</span> T&gt; requires </div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;    concepts::HasStringMethod&lt;T&gt; &amp;&amp;</div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;    (concepts::Printable&lt;T&gt; == <span class="keyword">false</span>)</div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;<span class="keyword">inline</span> <span class="keywordtype">void</span> print_atom(std::ostream&amp; out, <span class="keyword">const</span> <a class="code" href="structcpp20print_1_1printing_1_1PrintOptions.html">PrintOptions</a>&amp;, <span class="keyword">const</span> T&amp; t) {</div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;    out &lt;&lt; t.string(); </div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;}</div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160; </div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;<span class="keyword">template</span> &lt;concepts::UnicodeString T&gt; </div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;<span class="keyword">inline</span> <span class="keywordtype">void</span> print_atom(std::ostream&amp; out, <span class="keyword">const</span> PrintOptions&amp;, <span class="keyword">const</span> T&amp; t) {</div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;    out &lt;&lt; t; </div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;}</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160; </div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;<span class="keyword">template</span> &lt;concepts::Pr<span class="keywordtype">int</span>ableInteger T&gt;</div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;<span class="keyword">inline</span> <span class="keywordtype">void</span> print_atom(</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;        std::ostream&amp; out, </div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;        <span class="keyword">const</span> PrintOptions&amp; options, </div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;        <span class="keyword">const</span> T&amp; t</div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;        ) </div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;{</div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;    std::stringstream buffer;</div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160; </div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;    <span class="keywordflow">switch</span> (options.integerFormat) {</div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;        <span class="keywordflow">case</span> <a class="code" href="structcpp20print_1_1printing_1_1PrintOptions.html#a463c01fd3733281fe5fa6bda52436475a937504f318f04eaf0f1d701df4c4d7f3">PrintOptions::IntegerFormat::Decimal</a>:</div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;            buffer &lt;&lt; std::dec;</div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;            <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;        <span class="keywordflow">case</span> <a class="code" href="structcpp20print_1_1printing_1_1PrintOptions.html#a463c01fd3733281fe5fa6bda52436475a3a1733e5ccccdb1b700352409ce97c89">PrintOptions::IntegerFormat::Hexadecimal</a>:</div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;            buffer &lt;&lt; <span class="stringliteral">&quot;0x&quot;</span> &lt;&lt; std::hex;</div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;            <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;        <span class="keywordflow">case</span> <a class="code" href="structcpp20print_1_1printing_1_1PrintOptions.html#a463c01fd3733281fe5fa6bda52436475a919c181a7c4ea1da2e77d49e3c02d531">PrintOptions::IntegerFormat::Octal</a>:</div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;            buffer &lt;&lt; <span class="stringliteral">&quot;0o&quot;</span> &lt;&lt; std::oct;</div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;            <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;    }</div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160; </div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;    buffer &lt;&lt; static_cast&lt;long long int&gt;(t); </div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;    out &lt;&lt; buffer.str();</div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;}</div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160; </div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;<span class="keyword">template</span> &lt;concepts::Pr<span class="keywordtype">int</span>ableFloat T&gt;</div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;<span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="print__atom_8h.html#ad47012d4b2f909cec110fa350eae7192">print_atom</a>(</div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;        std::ostream&amp; out, </div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;        <span class="keyword">const</span> PrintOptions&amp; options, </div>
<div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;        <span class="keyword">const</span> T&amp; t</div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;        ) </div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;{</div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;    std::stringstream buffer;</div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160; </div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;    <span class="keywordflow">switch</span> (options.floatFormat) {</div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;        <span class="keywordflow">case</span> <a class="code" href="structcpp20print_1_1printing_1_1PrintOptions.html#aa900700142fa799baa05b7aa63fe3066a7a1920d61156abc05a60135aefe8bc67">PrintOptions::FloatFormat::Default</a>:</div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;            <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;            <span class="keywordflow">case</span> <a class="code" href="structcpp20print_1_1printing_1_1PrintOptions.html#aa900700142fa799baa05b7aa63fe3066a21234a0e100d74037a4da2e53f3200d7">PrintOptions::FloatFormat::Scientific</a>:</div>
<div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;            buffer.precision(options.floatPrecision);</div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;            buffer &lt;&lt; std::scientific;</div>
<div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;            <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;        <span class="keywordflow">case</span> <a class="code" href="structcpp20print_1_1printing_1_1PrintOptions.html#aa900700142fa799baa05b7aa63fe3066a4457d440870ad6d42bab9082d9bf9b61">PrintOptions::FloatFormat::Fixed</a>:</div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;            buffer.precision(options.floatPrecision);</div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;            buffer &lt;&lt; std::fixed;</div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;            <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;    }</div>
<div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160; </div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;    buffer &lt;&lt; t; </div>
<div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;    out &lt;&lt; buffer.str();</div>
<div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;}</div>
<div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160; </div>
<div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;}</div>
<div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160; </div>
<div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;<span class="preprocessor">#endif</span></div>
</div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="aprint__atom_8h_html_ad47012d4b2f909cec110fa350eae7192"><div class="ttname"><a href="print__atom_8h.html#ad47012d4b2f909cec110fa350eae7192">cpp20print::printing::detail::print_atom</a></div><div class="ttdeci">void print_atom(std::ostream &amp;out, const PrintOptions &amp;, const T &amp;)</div><div class="ttdoc">Prints single object. Fallback for all other objects.</div><div class="ttdef"><b>Definition:</b> print_atom.h:22</div></div>
<div class="ttc" id="astructcpp20print_1_1printing_1_1PrintOptions_html_a463c01fd3733281fe5fa6bda52436475a937504f318f04eaf0f1d701df4c4d7f3"><div class="ttname"><a href="structcpp20print_1_1printing_1_1PrintOptions.html#a463c01fd3733281fe5fa6bda52436475a937504f318f04eaf0f1d701df4c4d7f3">cpp20print::printing::PrintOptions::IntegerFormat::Decimal</a></div><div class="ttdeci">@ Decimal</div><div class="ttdoc">Decimal format (&quot;12&quot;)</div></div>
<div class="ttc" id="astructcpp20print_1_1printing_1_1PrintOptions_html"><div class="ttname"><a href="structcpp20print_1_1printing_1_1PrintOptions.html">cpp20print::printing::PrintOptions</a></div><div class="ttdoc">Sets the options of the print() function.</div><div class="ttdef"><b>Definition:</b> print_options.h:42</div></div>
<div class="ttc" id="aprint__concepts_8h_html"><div class="ttname"><a href="print__concepts_8h.html">print_concepts.h</a></div></div>
<div class="ttc" id="astructcpp20print_1_1printing_1_1PrintOptions_html_aa900700142fa799baa05b7aa63fe3066a4457d440870ad6d42bab9082d9bf9b61"><div class="ttname"><a href="structcpp20print_1_1printing_1_1PrintOptions.html#aa900700142fa799baa05b7aa63fe3066a4457d440870ad6d42bab9082d9bf9b61">cpp20print::printing::PrintOptions::FloatFormat::Fixed</a></div><div class="ttdeci">@ Fixed</div><div class="ttdoc">Fixed notation (&quot;1024.500&quot;)</div></div>
<div class="ttc" id="astructcpp20print_1_1printing_1_1PrintOptions_html_aa900700142fa799baa05b7aa63fe3066a21234a0e100d74037a4da2e53f3200d7"><div class="ttname"><a href="structcpp20print_1_1printing_1_1PrintOptions.html#aa900700142fa799baa05b7aa63fe3066a21234a0e100d74037a4da2e53f3200d7">cpp20print::printing::PrintOptions::FloatFormat::Scientific</a></div><div class="ttdeci">@ Scientific</div><div class="ttdoc">Scientific notation (&quot;1.0245e3&quot;)</div></div>
<div class="ttc" id="astructcpp20print_1_1printing_1_1PrintOptions_html_a463c01fd3733281fe5fa6bda52436475a3a1733e5ccccdb1b700352409ce97c89"><div class="ttname"><a href="structcpp20print_1_1printing_1_1PrintOptions.html#a463c01fd3733281fe5fa6bda52436475a3a1733e5ccccdb1b700352409ce97c89">cpp20print::printing::PrintOptions::IntegerFormat::Hexadecimal</a></div><div class="ttdeci">@ Hexadecimal</div><div class="ttdoc">Hexadecimal format (&quot;0xc&quot;)</div></div>
<div class="ttc" id="astructcpp20print_1_1printing_1_1PrintOptions_html_a463c01fd3733281fe5fa6bda52436475a919c181a7c4ea1da2e77d49e3c02d531"><div class="ttname"><a href="structcpp20print_1_1printing_1_1PrintOptions.html#a463c01fd3733281fe5fa6bda52436475a919c181a7c4ea1da2e77d49e3c02d531">cpp20print::printing::PrintOptions::IntegerFormat::Octal</a></div><div class="ttdeci">@ Octal</div><div class="ttdoc">Octal format (&quot;0o14&quot;)</div></div>
<div class="ttc" id="astructcpp20print_1_1printing_1_1PrintOptions_html_aa900700142fa799baa05b7aa63fe3066a7a1920d61156abc05a60135aefe8bc67"><div class="ttname"><a href="structcpp20print_1_1printing_1_1PrintOptions.html#aa900700142fa799baa05b7aa63fe3066a7a1920d61156abc05a60135aefe8bc67">cpp20print::printing::PrintOptions::FloatFormat::Default</a></div><div class="ttdeci">@ Default</div><div class="ttdoc">The system default (&quot;1024.5&quot;)</div></div>
<div class="ttc" id="aprint__options_8h_html"><div class="ttname"><a href="print__options_8h.html">print_options.h</a></div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.17
</small></address>
</body>
</html>
